! Copyright (C) GemTalk Systems 1986-2020.  All Rights Reserved.
! Class extensions for 'Behavior'

!		Instance methods for 'Behavior'

category: 'Updating the Method Dictionary'
method: Behavior
removeAllMethods: envId

"Removes all methods from the receiver.  This should not be done without
 considerable forethought!"

"FINAL implementation if Filein4Rowan"

| baseCats baseMeths |
self _validatePrivilege ifFalse:[ ^ nil ].
baseCats := self _baseCategorys: envId .
baseCats ifNotNil: [ baseCats removeAll ].
baseMeths := self persistentMethodDictForEnv: envId .
baseMeths ifNotNil: [
  envId == 0 ifTrue:[
    baseMeths keysDo: [:sel |
      self setStamp: nil forMethod: sel.
    ].
  ].
  baseMeths removeAll .
  baseMeths valueConstraint: GsNMethod . "to handle v2.3 to v3.0 image upgrade"
].
envId == 0 ifTrue:[
  GsPackagePolicy currentOrNil ifNotNil:[:pp| pp removeAllMethodsFor: self].
].
self _clearLookupCaches: envId .
%

! Class extensions for 'CompileError'

!		Instance methods for 'CompileError'

category: 'Formatting'
method: CompileError
errorDetails
  "Final implementation in AbstractException2.gs .
   Return nil or the array of compiler error details"
| arr |
arr := gsArgs ifNotNil:[:gsa | gsa atOrNil: 1 ] .
^ arr ifNil:[ { { 1075 . 1 . 'malformed CompilerError' } } ]. "STDB_MALFORMED_COMPILER_ERROR"
%

! Class extensions for 'DependencyList'

!		Class methods for 'DependencyList'

category: 'Accessing'
classmethod: DependencyList
for: anObject
  "real implementation later in filein, make rebuildTable: methods happy"
  ^ nil
%

! Class extensions for 'GsPackagePolicy'

!		Class methods for 'GsPackagePolicy'

category: 'Accessing'
classmethod: GsPackagePolicy
current
  ^ nil
%

category: 'Accessing'
classmethod: GsPackagePolicy
currentOrNil

 ^ nil
%

category: 'Initialize'
classmethod: GsPackagePolicy
deinitialize

  (GsSession currentSession objectNamed: #UserGlobals) removeKey: self globalName
       ifAbsent: [ nil ].
%

category: 'Accessing'
classmethod: GsPackagePolicy
enabled
  ^ false
%

category: 'Accessing'
classmethod: GsPackagePolicy
globalName

  ^#GsPackagePolicy_Current
%

category: 'Initialize'
classmethod: GsPackagePolicy
initialize
  ^ self deinitialize
%

! Class Initialization Excluded by export visitor
!  GsPackagePolicy initialize.
